/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Java2OWL;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import org.semanticweb.owlapi.expression.ParserException;
import org.semanticweb.owlapi.model.IRI;
import org.semanticweb.owlapi.model.OWLAxiom;
import org.semanticweb.owlapi.model.OWLClass;
import org.semanticweb.owlapi.model.OWLClassExpression;
import org.semanticweb.owlapi.model.OWLDataFactory;
import org.semanticweb.owlapi.model.OWLDataProperty;
import org.semanticweb.owlapi.model.OWLLiteral;
import org.semanticweb.owlapi.model.OWLNamedIndividual;
import org.semanticweb.owlapi.model.OWLObjectProperty;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyManager;
import org.semanticweb.owlapi.model.OWLOntologyStorageException;
import org.semanticweb.owlapi.model.OWLProperty;
import org.semanticweb.owlapi.reasoner.OWLReasoner;
import org.semanticweb.owlapi.vocab.OWL2Datatype;

/* *
 * @author ohlbach
 */
public class J2OOntologyManagerTest {
    static J2OManager manager = null;
    static J2OOntologyManager omg;
    static OWLOntologyManager om;
    static OWLDataFactory df;
    static J2OClassManager clm;
    static String EOFile = "test/Java2OWL/ExtensionOntology.owl";
    static OWLOntology extensionOntology;
    
    static OWLClass odead;
    static OWLClass oliving;
    static OWLDataProperty pHA;
    static OWLObjectProperty pHP;
      
    public J2OOntologyManagerTest() {
    }
    
    public String getName() {return "TestName";}
    
    @J2OWLClass(OWLSuperClasses = "LivingThing")
    static class T1 {}
    
    static Class jT1 = J2OOntologyManagerTest.T1.class;
    
    
    @J2OWLClass(name="OT2")
    static class T2 extends T1 {}
    static Class jT2 = J2OOntologyManagerTest.T2.class;
    
    static IRI extIri = IRI.create("http://www.lmu.de/ExtensionOntology.owl");
    
    void newExtOnt(String... individuals) {
        omg.setReasoner("HermiT", true, false, 10000);
        extensionOntology = omg.createExtensionOntology(true, extIri);
        for(String ind : individuals) omg.insertOWLIndividual(ind, oliving);}
    
    
        
    
    
    
    @BeforeClass
    public static void setUpClass() throws Exception {
        manager = new J2OManager("Testmanager", J2OManager.Status.COMPILE,true);
        Logging logger = manager.getLogger();
        //logger.activate(true);
        logger.activate(false);
        omg = manager.getOntologyManager(); 
        om = omg.ontologyManager;
        df = J2OOntologyManager.dataFactory;
        clm = manager.getClassManager();
        
        
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    
    /**
     * Test of object2Literal method, of class J2OOntologyManager.
     */
    @Test
    public void testObject2Literal() {
        System.out.println("object2Literal");
        Object object = new String("ABC");
        String result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("ABC", result);
      
        object = new Byte("3");
        result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("3", result);
        
        object = new Short("5");
        result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("5", result);
         
        object = new Integer(7);
        result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("7", result);
          
        object = new Long(74534534534453454l);
        result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("74534534534453454", result);
         
        object = new Float(9.5);
        result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("9.5", result);
        
        object = new Double(11.5);
        result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("11.5", result);
        
        object = new Boolean(true);
        result = J2OOntologyManager.object2Literal(object).getLiteral();
        assertEquals("true", result);
        
        object = new J2OOntologyManagerTest();
        assertEquals(null,J2OOntologyManager.object2Literal(object));
    }

     /**
     * Test of literal2Object method, of class J2OOntologyManager.
     */
    @Test
    public void testLiteral2Object() {
        System.out.println("literal2Object");
        Object in = new String("ABC");
        OWLLiteral literal = J2OOntologyManager.object2Literal(in);
        Object out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Byte("3");
        literal = J2OOntologyManager.object2Literal(in);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Short("5");
        literal = J2OOntologyManager.object2Literal(in);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Integer("7");
        literal = J2OOntologyManager.object2Literal(in);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Long(74534543453454435l);
        literal = J2OOntologyManager.object2Literal(in);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Float(9.5);
        literal = J2OOntologyManager.object2Literal(in);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Double(11.5);
        literal = J2OOntologyManager.object2Literal(in);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Boolean(true);
        literal = J2OOntologyManager.object2Literal(in);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        in = new Byte("34");
        literal = df.getOWLLiteral("34", OWL2Datatype.XSD_UNSIGNED_BYTE);
        out = omg.literal2Object(literal);
        assertEquals(in, out);
        
        // mehr Fälle testen
        
    }
    
   

    
    /**
     * Test of loadOntology method, of class J2OOntologyManager.
     */
    @Test
    public void testLoadOntology() throws Exception {
        System.out.println("loadOntology");
        String name = "test/Java2OWL/BackgroundOntology.owl";
        OWLOntology ontology = omg.loadBackgroundOntology(name);
        assertEquals("<http://www.lmu.de/BackgroundOntology.owl>", ontology.getOntologyID().toString());
       
        name = "test/Java2OWL/ExtensionOntology1.owl";
        ontology = omg.loadExtensionOntology(name);
        assertEquals("<http://www.lmu.de/ExtensionOntology1.owl>", ontology.getOntologyID().toString());
        
        omg.unloadOntology(false);
        
        ArrayList<OWLClass> classes = omg.getOWLClasses("DeadThing");
        odead = classes.iterator().next();
        classes = omg.getOWLClasses("LivingThing");
        oliving = classes.iterator().next();
        
        Set<OWLDataProperty> dataProperties = omg.getOWLDataProperties("hasAnything", true);
        pHA = dataProperties.iterator().next();
        
        Set<OWLObjectProperty>  objectProperties = omg.getOWLObjectProperties("hasPart", true);
        pHP = objectProperties.iterator().next();
        
        
        
    }

    /**
     * Test of createExtensionOntology method, of class J2OOntologyManager.
     */
    @Test
    public void testCreateExtensionOntology() throws Exception {
        System.out.println("createExtensionOntology");
        boolean importBO = true;
        IRI iri = IRI.create("http://www.lmu.de/ExtensionOntology.owl");
        
        OWLOntology ontology = omg.createExtensionOntology(false, iri);
        assertEquals(omg.getBackgroundOntology().getAxiomCount(), ontology.getAxiomCount());
        omg.unloadOntology(false);
        
        extensionOntology = omg.createExtensionOntology(importBO, iri);
        assertEquals("<http://www.lmu.de/ExtensionOntology.owl>", extensionOntology.getOntologyID().toString());
        assertEquals(1,extensionOntology.getImports().size());
        OWLOntology imported = extensionOntology.getImports().iterator().next();
        assertEquals("<http://www.lmu.de/BackgroundOntology.owl>", imported.getOntologyID().toString());
        
    }
    
    
    @Test
    public void testSetReasoner() {
        System.out.println("setReasoner");
        String reasonerName = "HermiT";
        boolean buffering = true;
        boolean monitorProgress = false;
        int timeout = 10000;
 
        OWLReasoner reasoner = omg.setReasoner(reasonerName, buffering, monitorProgress, timeout);
        assertEquals("HermiT",reasoner.getReasonerName());
    }
    
   
    /**
     * Test of getExtensionOntologyIRI method, of class J2OOntologyManager.
     */
    @Test
    public void testGetExtensionOntologyIRI() {
        System.out.println("getExtensionOntologyIRI");
        
        IRI expResult = IRI.create("http://www.lmu.de/ExtensionOntology.owl");
        IRI result = omg.getExtensionOntologyIRI();
        assertEquals(expResult, result);
    }

    /**
     * Test of getBackgroundOntologyIRI method, of class J2OOntologyManager.
     */
    @Test
    public void testGetBackgroundOntologyIRI() {
        System.out.println("getBackgroundOntologyIRI");
        
        IRI expResult = IRI.create("http://www.lmu.de/BackgroundOntology.owl");
        IRI result = omg.getBackgroundOntologyIRI();
        assertEquals(expResult, result);
    }

    /**
     * Test of createItemIRI method, of class J2OOntologyManager.
     */
    @Test
    public void testCreateItemIRI() {
        System.out.println("createItemIRI");
        String name = "Student";
        
        IRI expResult = IRI.create("http://www.lmu.de/ExtensionOntology.owl#Student");;
        IRI result = omg.createItemIRI(name);
        assertEquals(expResult, result);
    }

    /**
     * Test of makeOWLProperty method, of class J2OOntologyManager.
     */
    @Test
    public void testCreateOWLProperty() {
        System.out.println("createOWLProperty");
        String name = "dataProp";
        
        OWLProperty result = omg.makeOWLProperty(name, true);
        assertEquals("http://www.lmu.de/ExtensionOntology.owl#dataProp", result.toStringID().toString());
        assertEquals(true,result.isDataPropertyExpression());
        
        name = "objProp";
        result = omg.makeOWLProperty(name, false);
        assertEquals("http://www.lmu.de/ExtensionOntology.owl#objProp", result.toStringID().toString());
        assertEquals(false,result.isDataPropertyExpression());      
    }

     /**
     * Test of createOWLIndividual method, of class J2OOntologyManager.
     */
    @Test
    public void testgetEntities() {
        System.out.println("getClasses");
        ArrayList<OWLClass> classes = omg.getOWLClasses("DeadThing");
        assertEquals(1, classes.size());
        classes = omg.getOWLClasses("LivingThing");
        assertEquals(1, classes.size());
        
        System.out.println("getDataProperty");
        Set<OWLDataProperty> dataProperties = omg.getOWLDataProperties("hasAge", true);
        assertEquals(1, dataProperties.size());
        dataProperties = omg.getOWLDataProperties("hasAge", false);
        assertEquals(1, dataProperties.size());
        
        System.out.println("getObjectProperty");
        Set<OWLObjectProperty> objectProperties = omg.getOWLObjectProperties("hasPart", true);
        assertEquals(1, objectProperties.size());
        dataProperties = omg.getOWLDataProperties("hasPart", false);
        assertEquals(1, objectProperties.size());
        
        
        System.out.println("getOWLIndividuals");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("Jerry", true);
        assertEquals(1, individuals.size());
        individuals = omg.getOWLIndividuals("Jerry", false);
        assertEquals(1, individuals.size());
        
    }
   
    /**
     * Test of createOWLIndividual method, of class J2OOntologyManager.
     */
    @Test
    public void testCreateOWLIndividual() {
        System.out.println("createOWLIndividual");
        Object object = new Object();
        OWLClass ocl = omg.getOWLClasses("DeadThing").iterator().next();
        
        OWLNamedIndividual individual = omg.createOWLIndividual(object, ocl);
        assertEquals("DeadThing_0", individual.getIRI().getFragment());
        
        individual = omg.createOWLIndividual(object, ocl);
        assertEquals("DeadThing_1", individual.getIRI().getFragment());
        
        object = new J2OOntologyManagerTest();
        individual = omg.createOWLIndividual(object, ocl);
        assertEquals("TestName", individual.getIRI().getFragment());
        
    }
   
   /**
     * Test of individualMembershipAxiom method, of class J2OOntologyManager.
     */
    @Test
    public void testGetMembershipAxiom() {
        System.out.println("getMembershipAxiom");
        Object object = new Object();
        OWLClass ocl = omg.getOWLClasses("DeadThing").iterator().next();
        OWLNamedIndividual individual = omg.createOWLIndividual(object, ocl);
        assertEquals("DeadThing_2", individual.getIRI().getFragment());
        
        OWLAxiom axiom = J2OOntologyManager.getMembershipAxiom(individual, ocl);
        assertEquals("ClassAssertion(<http://www.lmu.de/BackgroundOntology.owl#DeadThing> <http://www.lmu.de/ExtensionOntology.owl#DeadThing_2>)", axiom.toString());
    }
    
     /**
     * Test of class2OWL method, of class J2OOntologyManager.
     */
    @Test
    public void testClass2OWL() throws OWLOntologyStorageException, J2OException {
        System.out.println("class2OWL");
        ClassWrapper expResult = null;
        ClassWrapper cmd = omg.class2OWL(jT1);
        omg.applyChanges(false);
        OWLClass ot1 = cmd.getOWLClass();
        assertEquals(jT1,cmd.getJavaClass());
        assertEquals("http://www.lmu.de/ExtensionOntology.owl#T1",ot1.toStringID());
        Set<OWLClassExpression> sc = cmd.getOWLClass().getSuperClasses(extensionOntology);
        assertEquals(1,sc.size());
        assertEquals(oliving,sc.iterator().next());
        
        cmd = omg.class2OWL(jT2);
        assertEquals(jT2,cmd.getJavaClass());
        sc = cmd.getOWLClass().getSuperClasses(extensionOntology);
        assertEquals(1,sc.size());
        assertEquals(ot1,sc.iterator().next());
        assertEquals("http://www.lmu.de/ExtensionOntology.owl#OT2",cmd.getOWLClass().toStringID());        
        //omg.saveExtensionOntology(EOFile);       
    }

   
  /**
     * Test of makeDataPropertyAxioms method, of class J2OOntologyManager.
     */
    @Test
    public void testmakeDataPropertyAxioms() throws OWLOntologyStorageException {
        System.out.println("makeDataPropertyAxioms");
        Object object = new Object();
        OWLClass ocl = omg.getOWLClasses("DeadThing").iterator().next();
        OWLNamedIndividual individual = omg.createOWLIndividual(object, ocl);
        assertEquals("DeadThing_3", individual.getIRI().getFragment());
         
        OWLDataProperty property = pHA;
        Object value = new Integer(3);
        ArrayList<OWLAxiom> axioms = new ArrayList<OWLAxiom>();
        
        boolean result = omg.makeDataPropertyAxioms(individual, property, value, axioms);
        assertEquals(true, result);
        assertEquals(1,axioms.size());
        assertEquals("[DataPropertyAssertion(<http://www.lmu.de/BackgroundOntology.owl#hasAnything> <http://www.lmu.de/ExtensionOntology.owl#DeadThing_3> \"3\"^^xsd:integer)]",axioms.toString());
       
        Set<String> strings = new HashSet<String>();
        strings.add("ABC"); strings.add("DEF");
        
        result = omg.makeDataPropertyAxioms(individual, property, strings, axioms);
        assertEquals(true, result);
        assertEquals(3,axioms.size());
        
        Short[] shorts = {7,8,9};
        result = omg.makeDataPropertyAxioms(individual, property, shorts, axioms);
        assertEquals(true, result);
        assertEquals(6,axioms.size());
        J2OOntologyManagerTest[] st = {new J2OOntologyManagerTest()};
        manager.setDebugMode(false);
        result = omg.makeDataPropertyAxioms(individual, property, st, axioms);
        manager.setDebugMode(true);
        assertEquals(false, result);
        
        
        omg.addOWLAxiom(J2OOntologyManager.getMembershipAxiom(individual,ocl));
        omg.addOWLAxioms(axioms);
        omg.saveExtensionOntology(EOFile); 
    }
  
     /**
     * Test of getDataPropertyValues method, of class J2OOntologyManager.
     */
    @Test
    public void testGetDataPropertyValues() {
        System.out.println("getDataPropertyValues");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("DeadThing_3", false);
        OWLNamedIndividual individual = individuals.iterator().next();
        Set<Object> result = omg.getDataPropertyValues(individual, pHA);
        assertEquals("[ABC, 3, DEF, 7, 8, 9]", result.toString());
    }

     /**
     * Test of changeDataProperty method, of class J2OOntologyManager.
     */
    @Test
    public void testChangeDataProperty_4args_1() throws OWLOntologyStorageException {
        System.out.println("changeDataProperty insert/remove");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("DeadThing_3", false);
        OWLNamedIndividual individual = individuals.iterator().next();
        boolean insert = false;
        Short value = 7;
        boolean result = omg.changeDataProperty(individual, pHA, value, insert);
        assertEquals(true, result);
        assertEquals("[ABC, 3, DEF, 8, 9]", omg.getDataPropertyValues(individual, pHA).toString());
        
        value = 88;
        result = omg.changeDataProperty(individual, pHA, value, true);
        assertEquals(true, result);
        assertEquals("[ABC, 3, DEF, 8, 9, 88]", omg.getDataPropertyValues(individual, pHA).toString());
        
        //omg.saveExtensionOntology(EOFile); 
    }

    /**
     * Test of changeObjectProperty method, of class J2OOntologyManager.
     */
    @Test
    public void testChangeDataProperty() throws OWLOntologyStorageException {
        System.out.println("changeDataProperty change");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("DeadThing_3", false);
        OWLNamedIndividual individual = individuals.iterator().next();
        
        Short oldValue = 88;
        Short newValue = 99;
        boolean result = omg.changeDataProperty(individual, pHA, oldValue, newValue);
        
        assertEquals(true, result);
        assertEquals("[ABC, 3, DEF, 99, 8, 9]", omg.getDataPropertyValues(individual, pHA).toString());
        
        //omg.saveExtensionOntology(EOFile); 
    }

    
     /**
     * Test of getObjectPropertyValues method, of class J2OOntologyManager.
     */
    @Test
    public void testGetObjectPropertyValues() {
        System.out.println("getObjectPropertyValues");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("Jerry", false);
        OWLNamedIndividual individual = individuals.iterator().next();
        
        Set<OWLNamedIndividual> result = omg.getObjectPropertyValues(individual, pHP);
        assertEquals(1, result.size());
        assertEquals("[<http://www.lmu.de/BackgroundOntology.owl#heater>]",result.toString());
  }

  /**
     * Test of changeObjectProperty method, of class J2OOntologyManager.
     */
    @Test
    public void testChangeObjectProperty1() throws OWLOntologyStorageException {
        System.out.println("changeObjectProperty insert/remove");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("DeadThing_3", false);
        OWLNamedIndividual dt3 = individuals.iterator().next();
        
        OWLClass ocl = omg.getOWLClasses("DeadThing").iterator().next();
        Object object = new Object();
        OWLNamedIndividual dt4 = omg.createOWLIndividual(object, ocl);
        omg.addOWLAxiom(J2OOntologyManager.getMembershipAxiom(dt4, ocl));
        
        omg.changeObjectProperty(dt3, pHP, dt4,true);
        Set<OWLNamedIndividual> result = omg.getObjectPropertyValues(dt3, pHP);
        assertEquals("[<http://www.lmu.de/ExtensionOntology.owl#DeadThing_4>]",result.toString());
        
        omg.changeObjectProperty(dt3, pHP, dt4,false);
        result = omg.getObjectPropertyValues(dt3, pHP);
        assertEquals(true,result.isEmpty());
        //omg.saveExtensionOntology(EOFile);     
    }
    
    /**
     * Test of changeObjectProperty method, of class J2OOntologyManager.
     */
    @Test
    public void testChangeObjectProperty2() throws OWLOntologyStorageException {
        System.out.println("changeObjectProperty change");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("DeadThing_3", false);
        OWLNamedIndividual dt3 = individuals.iterator().next();
        individuals = omg.getOWLIndividuals("DeadThing_4", false);
        OWLNamedIndividual dt4 = individuals.iterator().next();
      
        omg.changeObjectProperty(dt3, pHP, dt4,true);
        
        omg.changeObjectProperty(dt3, pHP, dt4,dt3);
        Set<OWLNamedIndividual> result = omg.getObjectPropertyValues(dt3, pHP);
        assertEquals("[<http://www.lmu.de/ExtensionOntology.owl#DeadThing_3>]",result.toString());
        omg.saveExtensionOntology(EOFile);     
    }
 
    /**
     * Test of getOWLClasses method, of class J2OOntologyManager.
     */
    @Test
    public void testGetOWLClasses() {
        System.out.println("getOWLClasses");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("DeadThing_3", false);
        OWLNamedIndividual dt3 = individuals.iterator().next();
        Set<OWLClass> result = omg.getOWLClasses(dt3);
        assertEquals("[<http://www.lmu.de/BackgroundOntology.owl#DeadThing>]", result.toString());
    }
 
  

    /**
     * Test of parseClassExpression method, of class J2OOntologyManager.
     */
    @Test
    public void testParseClassExpression() throws Exception {
        System.out.println("parseClassExpression");
        String classExpressionString = "DeadThing";
        
        OWLClassExpression result = omg.parseClassExpression(classExpressionString);
        assertEquals("<http://www.lmu.de/BackgroundOntology.owl#DeadThing>", result.toString());
        
        classExpressionString = "DeadThing and LivingThing";
        
        result = omg.parseClassExpression(classExpressionString);
        assertEquals("ObjectIntersectionOf(<http://www.lmu.de/BackgroundOntology.owl#DeadThing> <http://www.lmu.de/BackgroundOntology.owl#LivingThing>)", result.toString());
    }
    
     /**
     * Test of parseClassExpression method, of class J2OOntologyManager.
     */
    @Test
    public void testGetInstances() throws Exception {
        System.out.println("getInstances");
        String classExpressionString = "DeadThing";
        
        Set<OWLNamedIndividual> result = omg.getInstances(classExpressionString);
        //System.out.println("IN " + people);
        assertEquals(4, result.size());
        
        classExpressionString = "DeadThing or LivingThing";
        
        result = omg.getInstances(classExpressionString);
        //System.out.println("IN " + people);
        assertEquals(4, result.size());
        
        result = omg.getInstances(omg.parseClassExpression(classExpressionString));
        assertEquals(4, result.size());
    }
    
     /**
     * Test of removeIndivdual method, of class J2OOntologyManager.
     */
    @Test
    public void testRemoveIndividual() throws OWLOntologyStorageException {
        System.out.println("removeIndividual");
        Set<OWLNamedIndividual> individuals = omg.getOWLIndividuals("DeadThing_3", false);
        OWLNamedIndividual dt3 = individuals.iterator().next();
        omg.removeIndividual(dt3);
        //omg.saveExtensionOntology(EOFile);   
    }
    
    @Test
    public void testSetDataProperty() throws ParserException {
        System.out.println("setDataProperty");
        newExtOnt("Tom", "Tim", "Michael", "Frank", "John");
        Set<OWLNamedIndividual> result = omg.getInstances("LivingThing");
        assertEquals(5, result.size());
        String[] names = J2OOntologyManager.getEntityNames(result);
        assertEquals("[Frank, John, Michael, Tim, Tom]",Arrays.toString(names));
        OWLNamedIndividual frank = result.iterator().next();
        omg.setDataProperty(frank, pHA, 76);
        Set<Object> values = omg.getDataPropertyValues(frank, pHA);
        assertEquals(1,values.size());
        
        omg.setDataProperty(frank, pHA, "AGE");
        values = omg.getDataPropertyValues(frank, pHA);
        assertEquals(1,values.size());
        assertEquals("AGE",values.iterator().next());
        
        List<Object> val = Utilities.asList(4,5,"AA","BB");
        omg.setDataProperties(frank, pHA, val);
        values = omg.getDataPropertyValues(frank, pHA);
        assertEquals(4,values.size());
        assertEquals("[AA, BB, 4, 5]",values.toString());
        
        val = Utilities.asList("AA","BB",6,7);
        omg.setDataProperties(frank, pHA, val);
        values = omg.getDataPropertyValues(frank, pHA);
        assertEquals(4,values.size());
        assertEquals("[AA, BB, 6, 7]",values.toString());
    }
    
    @Test
    public void testSetObjectProperty() throws ParserException {
        System.out.println("setObjectProperty"); 
        newExtOnt("Tom", "Tim", "Michael", "Frank", "John");
        Set<OWLNamedIndividual> people = omg.getInstances("LivingThing");
        String[] names = J2OOntologyManager.getEntityNames(people);
        assertEquals("[Frank, John, Michael, Tim, Tom]",Arrays.toString(names));
        Iterator<OWLNamedIndividual> it = people.iterator();
        OWLNamedIndividual frank = it.next();
        OWLNamedIndividual john = it.next();
        OWLNamedIndividual michael = it.next();
        OWLNamedIndividual tim = it.next();
        OWLNamedIndividual tom = it.next();
        
        omg.setObjectProperty(frank, pHP, michael);
        Set<OWLNamedIndividual> values = omg.getObjectPropertyValues(frank, pHP);
        assertEquals(1,values.size());
        assertEquals(michael,values.iterator().next());
        
        omg.setObjectProperties(frank, pHP, people);
        values = omg.getObjectPropertyValues(frank, pHP);
        assertEquals(people,values);
        
        omg.setObjectProperty(frank, pHP, tim);
        values = omg.getObjectPropertyValues(frank, pHP);
        assertEquals(1,values.size());
        assertEquals(tim,values.iterator().next());
        
        
    }
       
   
}
