/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Java2OWL;

import TestPackage.SimpleStudent.Freshman;
import org.semanticweb.owlapi.model.OWLDataProperty;
import TestPackage.SimpleStudent;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author ohlbach
 */
public class ReasonerTest {
    static J2OManager manager;
    static J2OOntologyManager omg;
    static J2OClassManager clm;
    static J2OIndividualManager img;
    
    public ReasonerTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of apply method, of class Function.
     */
    @Test
    public void testPellet() {
        System.out.println("Pellet");
        manager = new J2OManager("TestManager",J2OManager.Status.RUN,true);
        manager.getLogger().activateInfo(false);
        omg = manager.getOntologyManager();
        clm = manager.getClassManager();
        omg.setReasoner("Pellet", true, false, 10000);
        
        
        String name = "test/TestPackage/SimpleStudent.owl";
        omg.loadExtensionOntology(name);
        
        
        J2OCompiler comp = manager.getCompiler();
        comp.class2OWL(SimpleStudent.class);
        comp.finishTranslation();  
         
        img = manager.getIndvidualManager();
        
        clm.activateSynchronisation(SimpleStudent.class);
        
        SimpleStudent James = new SimpleStudent("James",4);
        
        IndividualWrapper james = img.object2OWL(James);
        assertNotNull(james);
        assertEquals("James",james.getIndividual().getIRI().getFragment());
        
        James.setSemester(1);
        
        OWLDataProperty hasMentor = omg.getFirstOWLDataProperty("hasMentor");
        james.setDataPropertyValue(hasMentor, "Billy");
        james.reclassify(false);
        
        Object student = james.getFirstObject();
        
        assertTrue(student instanceof Freshman);
       
    }
    
    @Test
    public void testFact() {
        System.out.println("FaCT++");
        manager = new J2OManager("TestManager",J2OManager.Status.RUN,true);
        manager.getLogger().activateInfo(false);
        omg = manager.getOntologyManager();
        omg.setReasoner("FaCT++", true, false, 10000);
        clm = manager.getClassManager();
        
        String name = "build/test/classes/TestPackage/SimpleStudent.owl";
        omg.loadExtensionOntology(name);
        
        
        J2OCompiler comp = manager.getCompiler();
        comp.class2OWL(SimpleStudent.class);
        comp.finishTranslation();  
         
        img = manager.getIndvidualManager();
        
        clm.activateSynchronisation(SimpleStudent.class);
        
        SimpleStudent James = new SimpleStudent("James",4);
        
        IndividualWrapper james = img.object2OWL(James);
        assertNotNull(james);
        assertEquals("James",james.getIndividual().getIRI().getFragment());
        
        James.setSemester(1);
        
        OWLDataProperty hasMentor = omg.getFirstOWLDataProperty("hasMentor");
        james.setDataPropertyValue(hasMentor, "Billy");
        james.reclassify(false);
        
        Object student = james.getFirstObject();
        
        assertTrue(student instanceof Freshman);
        
     }
    
}
