/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Java2OWL;

import TestPackage.SimpleStudent.Teacher;
import org.semanticweb.owlapi.model.OWLObjectProperty;
import org.semanticweb.owlapi.model.OWLDataProperty;
import TestPackage.SimpleStudent.Freshman;
import TestPackage.SimpleStudent;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/** This class tests the reclassification operation.
 * Run SimpleStudent.java first!
 *
 * @author ohlbach
 */
public class ReclassifyTest {
    static J2OManager manager;
    static J2OOntologyManager omg;
    static J2OClassManager clm;
    static J2OIndividualManager img;
    
    public ReclassifyTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
        manager = new J2OManager("TestManager",J2OManager.Status.RUN,true);
        manager.getLogger().activateInfo(false);
        omg = manager.getOntologyManager();
        
        clm = manager.getClassManager();
        String name = "test/TestPackage/SimpleStudent.owl";
        omg.loadExtensionOntology(name);
        
        
        J2OCompiler comp = manager.getCompiler();
        comp.class2OWL(SimpleStudent.class);
        comp.finishTranslation();  
         
        img = manager.getIndvidualManager();
        
        clm.activateSynchronisation(SimpleStudent.class);
        
        
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of apply method, of class Function.
     */
    @Test
    public void testReclassify() {
        System.out.println("reclassify");
        
        SimpleStudent James = new SimpleStudent("James",4);
        
        IndividualWrapper james = img.object2OWL(James);
        
        
        assertNotNull(james);
        assertEquals("James",james.getIndividual().getIRI().getFragment());
        
        James.setSemester(1);
        
        OWLDataProperty hasMentor = omg.getFirstOWLDataProperty("hasMentor");
        james.setDataPropertyValue(hasMentor, "Billy");
        
        
        
        james.reclassify(false);
        
        Object student = james.getFirstObject();
        
        assertTrue(student instanceof Freshman);
        Freshman freshman = (Freshman)student;
        
        assertEquals("James",freshman.getName());
        assertEquals("Billy",freshman.getMentor());
        String mentor = (String)(james.getDataPropertyValues(hasMentor).iterator().next());
        assertEquals("Billy",mentor);
        assertTrue(freshman.getMentor() == mentor); 
        
        OWLObjectProperty teaches = omg.getFirstOWLObjectProperty("teaches");
        
        james.setObjectPropertyValue(teaches, James);
        
        omg.saveExtensionOntology();
        
        james.reclassify(false);
         
        assertEquals(2,james.getObjects().length);
        
        Teacher teacher = (Teacher)james.getObject(Teacher.class);
        assertNotNull(teacher);
        assertEquals(1,teacher.getStudents().size());
        assertTrue(freshman == teacher.getStudents().iterator().next());
       
        assertTrue(freshman == james.getObject(Freshman.class));
        
        //omg.saveExtensionOntology();
        
    }
    
    

    
}
