/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Java2OWL;

import TestPackage.TestItem;
import java.util.HashSet;
import java.util.Set;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author ohlbach
 */

public class TransitivityTest {
     
    static J2OManager manager;
    static J2OOntologyManager omg;
    static J2OClassManager clm;
    static J2OIndividualManager img;
    
    public TransitivityTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
        manager = new J2OManager("TestManager",J2OManager.Status.RUN,true);
        manager.getLogger().activateInfo(false);
        omg = manager.getOntologyManager();
        
        clm = manager.getClassManager();
        String name = "test/TestPackage/Item.owl";
        omg.loadExtensionOntology(name);
        
        J2OCompiler comp = manager.getCompiler();
        comp.class2OWL(TestItem.class);
        comp.finishTranslation();  
         
        img = manager.getIndvidualManager();
        
        clm.activateSynchronisation(TestItem.class);
        
        
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }
    
      /**
     * Test of apply method, of class Function.
     */
    @Test
    public void testTransitivity() {
        System.out.println("transitivity");
        
        TestItem item1 = new TestItem();
        TestItem item2 = new TestItem();
        IndividualWrapper it1 = img.object2OWL(item1);
        IndividualWrapper it2 = img.object2OWL(item2);
        item1.addItem(item2);
        TestItem item3 = new TestItem();
        IndividualWrapper it3 = img.object2OWL(item3);
        item2.addItem(item3);
        
        omg.saveExtensionOntology();
        assertEquals(1,item1.getItems().size());
       
        it1.reclassify(true);
        
        assertEquals(3,((TestItem)(it1.getFirstObject())).getItems().size());
        assertEquals(3,item1.getItems().size());
        
    }
    
}
